

-- TP2 :  Cration d'un schma pour le traitement des marques dposes ---



\c tpmarquedeposees;


-- les tables vont tre cres dans le schma de l'utilisateur courant


-- Suppression des tables existantes dans l'ordre inverse de leur cration

DROP TABLE ventes ;
DROP  TABLE enregistrements  ;
DROP TABLE refus  ;
DROP TABLE depots  ;
DROP TABLE marque_new  ;
DROP TABLE groupes_societes  ;
DROP TABLE statuts  ;
DROP TABLE groupes  ;






-- Cration des tables pour le traitement des marques dposes 


CREATE TABLE groupes (
       IdGroupe INT  PRIMARY KEY);

CREATE TABLE groupes_societes (
       IdGroupe INT  NOT NULL REFERENCES groupes,
       IdSociete INT  NOT NULL REFERENCES societe,
       primary key (IdGroupe, IdSociete ));

CREATE TABLE statuts (
       Id char  PRIMARY KEY,
       Nom varchar(20) NOT NULL);
insert into statuts values ('d', 'dpose');
insert into statuts values ('n', 'nouvelle');
insert into statuts values ('l', 'libre');
insert into statuts values ('e', 'enregistre');
 
      
CREATE TABLE marque_new (
       IdMarque INT  PRIMARY KEY CHECK (IdMarque>=1000 and IdMarque <100000),
       Nom varchar(20) NOT NULL,
       Classe INT  NOT NULL,
       Statut char DEFAULT 'n' NOT NULL references statuts,
       Pays char(2) NOT NULL REFERENCES pays,
       IdGroupe INT  REFERENCES groupes,
       CONSTRAINT Cle_Sec1 UNIQUE (Nom,Classe,Pays));


CREATE TABLE depots (
       NumLegal INT NOT NULL,
       Pays char(2) NOT NULL REFERENCES pays,
		PRIMARY KEY (NumLegal,Pays),
       DateDepot date NOT NULL,
       IdMarque INT  NOT NULL REFERENCES marque_new,
       IdGroupe INT  NOT NULL REFERENCES groupes
);
      

CREATE TABLE refus (
      	NumDepot INT NOT NULL,
       	PaysDepot char(2) NOT NULL REFERENCES pays,
		FOREIGN KEY (NumDepot,PaysDepot) REFERENCES Depots,
      	 DateRefus date NOT NULL)
;
-- La table refus est ncessaire si on veut memoriser la date de refus


CREATE TABLE enregistrements (
       NumLegal INT NOT NULL,
       Pays char(2) NOT NULL REFERENCES pays,
		PRIMARY KEY (NumLegal,Pays),
       DateEnreg date NOT NULL,
       	NumDepot INT NOT NULL,
       	PaysDepot char(2) NOT NULL REFERENCES pays,
		FOREIGN KEY (NumDepot,PaysDepot) REFERENCES Depots
);

/*
Contrainte textuelle : 
Une marque enregistree doit forcement avoir t dpose: dans cette table, 
un enregistrement fait reference a un numro de dpot et par consquent 
la contrainte est toujours verifiee 
*/

CREATE TABLE ventes (
        IdVente SERIAL PRIMARY KEY,   -- Ajout pour facilit la rfrence  la vente prcdente
       	NumLegal INT NOT NULL,
       	PaysVente char(2) NOT NULL REFERENCES pays,
		UNIQUE (NumLegal,PaysVente),
       	DateVente date NOT NULL,
       	IdGroupe INT  NOT NULL REFERENCES groupes,
       	IdEnreg INT  NOT NULL,
       	PaysEnreg  char(2) NOT NULL REFERENCES pays,
		FOREIGN KEY (IdEnreg,PaysEnreg)   REFERENCES  enregistrements,
	VentePrec INT REFERENCES ventes) ;
/*
 Contrainte textuelle : 
Une marque ne peut etre vendue que si elle est enregistre.
Dans notre table, une vente fait rfrence a un numro d'enregistrement et
par consquent la contrainte est toujours vrifie
*/

